class Enemy extends Entity
{
  int mode = 0; //mode = 0 is flying towards planet, mode = 1 is standing on planet.
  
  boolean dirLeft = true;

  PVector velocity = new PVector(0,0,0);
  float maxAirVel = 4;
  
  PVector down = new PVector(0,0,0);
  Planet onPlanet;

  boolean grounded = false;

  PImage img;

  float radius; //for starters, after basic system in, will implement rotation and quad coll.

  Quad2D originalQuadd;
  Quad2D quadd;
  

  Enemy(){}

  Enemy(PVector iPos, PVector iVel, PImage iImg)
  {
    img =iImg;
    radius = 43/2;      
    pos = iPos;
    quadd = new Quad2D(pos, 43, 43);
    originalQuadd = new Quad2D(pos, 43, 43);
    
    velocity.set(iVel);
    velocity.normalize();
    velocity.mult(maxAirVel);
  }

  //  void Move(int hor, int ver)
  //  {
  //    
  //    pos = new PVector(hor, ver, pos.z);
  //    quadd.Translate(new PVector(hor, ver, 0));
  //    swordQuad.Translate(new PVector(hor, ver, 0));
  //  }

  void Update(long elapsedTime)
  {
    if (mode == 0)
    {
    Translate(velocity);
    }
    else if (mode == 1)
    {
    }
  }

  void Translate(PVector iVelocity)
  {
    //iVelocity.mult(0.15);

    pos.add(iVelocity);

    //  quadd.MoveTo(pos);

    quadd.Translate(iVelocity);

  }

  float FindAngle2D(PVector v1, PVector v2)
  {
    //float angle = -(180/PI)*atan2(v1.x*v2.y - v1.y*v2.x, v1.x*v2.x+v1.y*v2.y);
    float angle = -atan2(v1.x*v2.y - v1.y*v2.x, v1.x*v2.x+v1.y*v2.y);

    return angle;
  }

  PVector ReturnNormal(PVector v1, boolean clockwise)
  {
    PVector normalV1 = new PVector();
    normalV1.set(v1);

    if (clockwise)
    {
      float y = normalV1.y;
      normalV1.y = -normalV1.x;
      normalV1.x = y;
    }
    else
    {
      float y = normalV1.y;
      normalV1.y = normalV1.x;
      normalV1.x = -y;
    }

    return normalV1;
  }

  void MirrorPlayer()
  {
    quadd.MirrorQuad(down, pos);
   
    PVector temp0 = new PVector();
    temp0.set( originalQuadd.points[0]);
    PVector temp2 = new PVector();
    temp2.set( originalQuadd.points[2]);

    originalQuadd.points[0] = originalQuadd.points[1];
    originalQuadd.points[1] = temp0;
    originalQuadd.points[2] = originalQuadd.points[3];
    originalQuadd.points[3] = temp2;
  }

  
  void SetEnemyAngle()
  {
    //set enemy
    float anglebetween = FindAngle2D( PVector.sub(down, pos), new PVector(0,1,0) );
    originalQuadd.MoveTo(pos);    
    quadd = originalQuadd.RotateQuad(pos,anglebetween);
  }
  

  void Draw()
  {
    quadd.Draw(img);

  }

}



