class EnemyManager extends Entity
{
  ArrayList enemiesList = new ArrayList();

  int spawnCounter = 0; //counts time

  float spawnTime = 10000; //time between each spawn in miliseconds
  float minSpawnTime = 2000; //minimum time between each spawn in miliseconds
  float spawnTimeMod = 0.95; //0.94 each time an enemy spawns, the spawn time is multiplied by this number.

  float spawnDistance = 2000; //distance away from the play to spawn.
  PImage enemyImg = loadImage("mousemonster.png");
  EnemyManager(){
    
  }

  void Update(long elapsedTime, PVector playerPos, PVector planetPos)
  {
    spawnCounter += elapsedTime;
    if (spawnCounter >= spawnTime)
    {
      spawnCounter = 0;
      spawnTime *= spawnTimeMod;
      if (spawnTime < minSpawnTime)
        spawnTime = minSpawnTime;

      float spawnAngle = random(360);
      spawnAngle /= 180 / PI;
      PVector spawnLocation = new PVector();
      spawnLocation = new PVector(playerPos.x, playerPos.y + spawnDistance, 0); 
      spawnLocation = RotateVector(playerPos, spawnAngle, spawnLocation);
      enemiesList.add(new Enemy(spawnLocation, PVector.sub(planetPos, spawnLocation), enemyImg));

    }


    for (int i = 0; i < enemiesList.size(); i++)
    {
      ((Enemy)enemiesList.get(i)).Update(elapsedTime);
    }   

  }

  void Draw()
  {
    for (int i = 0; i < enemiesList.size(); i++)
    {
      ((Enemy)enemiesList.get(i)).Draw();
    } 

  }

  PVector  RotateVector(PVector rotAxis, float rotAmount, PVector rotVec)
  {
    PVector rotateVec = new PVector();
    rotateVec.set(rotVec);
    rotateVec.sub(rotAxis);
    PVector returnVec = new PVector();

    returnVec.x = (rotateVec.x *(cos(rotAmount))) - (rotateVec.y *(sin(rotAmount)));
    returnVec.y = (rotateVec.x *(sin(rotAmount))) + (rotateVec.y *(cos(rotAmount)));
    returnVec.add(rotAxis);
    return returnVec;
  }

}




