//import java.awt.AWTException; 
//import java.awt.Robot; 
//import java.awt.event.KeyEvent;
//import java.awt.Frame;

class Play extends GameState
{
  GUI gui;
  
  float mouseInputThreshold = 1500;
  PImage planetImg = loadImage("smallmarbleplanet.png");
   PImage medPlanetImg = loadImage("medmarbleplanet.png");
  PImage planetEffectImg = loadImage("purple50.png");
    
  int centerPosX, centerPosY; //where the mouse needs to reset to.
  boolean mouseLocked = true;
  Camera3D cameraa;
  Player p1; 
  ArrayList planetList;
  int inputCounter = -1;

  float maxMouseSpeed = 14;
  float farAwayPlanetaryPull = 4.25; //strength of force when outside of all planets effect range

  EnemyManager enMan;
  
  Play()
  {        
    
    enMan = new EnemyManager();
    cameraa = new Camera3D();
    p1 = new Player(new PVector(0, 0-216 , 0), 32, 32);
    planetList = new ArrayList();
    planetList.add(new Planet(new PVector(0 - 100, 0 - 100 , 0), 100,planetImg, planetEffectImg));    
    planetList.add(new Planet(new PVector(width/2, height/2 +200, 0), 200,planetImg, planetEffectImg));
    planetList.add(new Planet(new PVector(width/2 + 850, height/2 +850 , 0), 500,medPlanetImg, planetEffectImg));
    planetList.add(new Planet(new PVector(width/2 + 1800, height/2 - 160 , 0), 350,medPlanetImg, planetEffectImg));
    planetList.add(new Planet(new PVector(width/2 + 1950, height/2 - 1250 , 0), 250,planetImg, planetEffectImg));
    planetList.add(new Planet(new PVector(width/2 + 1200, height/2 -630 , 0), 50,planetImg, planetEffectImg));
    planetList.add(new Planet(new PVector(width/2 -400, height/2 +1050 , 0), 300,medPlanetImg, planetEffectImg));    
    planetList.add(new Planet(new PVector(width/2 -1100, height/2 +800 , 0), 150,planetImg, planetEffectImg)); 
    planetList.add(new Planet(new PVector(width/2 -1400, height/2 +1000 , 0),100,planetImg, planetEffectImg));    
    
    gui = new GUI(cameraa, p1);
    //ResetMouse();

    CollisionPlayerOnPlanet(); //check and handle collisions as soon as play start
  }
  
int   counter = 0;
  int TakeInput(long elapsedTime)
  {
    if(keyPressed)
    {
      //check to see if the player changes the game state (ie. pushes q to quit)
    }

    if(left == true && right == false) 
    {
      if (p1.grounded && p1.jumping == false)
      {
        counter++;
        System.out.println(counter);
        p1.jumping = true;
        p1.jumpCounter = 0;
        p1.grounded = false;
        PVector jumpV = PVector.sub(p1.pos, p1.onPlanet.pos);
        jumpV.normalize();
        p1.velocity.add( PVector.mult(  jumpV, p1.jumpPower  )   );

      }
      else if (p1.jumping == true)
      {

        if (p1.jumpCounter < p1.jumpMax)
        {

          p1.jumpCounter+= elapsedTime;
          PVector jumpV = PVector.sub(p1.pos, p1.onPlanet.pos);
          jumpV.normalize();
          p1.velocity.add(PVector.mult(  PVector.mult(  jumpV,  (float)(p1.jumpMax - p1.jumpCounter) * elapsedTime  )  , p1.jumpBoost ));
        }
        else
        {
          //p1.jumping = false; 
          //p1.jumpCounter = 0;
        }
      }             
    } 
    else
    {


      p1.jumping = false;
      p1.jumpCounter = 0;
    }

    //swing the sword.
    if(right == true) 
    {
      if (!p1.grounded )
        p1.currentAttackTimeInAir += elapsedTime;
        
        p1.currentAttackTime += elapsedTime;
      
    //  if (p1.currentAttackTime <= p1.attackTime)
    //  {
      
        //continue the previous input for a given amount of time.
        p1.mouseInput.set(p1.prevMouseInput);
        
    //  }
     // else
    //  {
     //   p1.mouseInput = new PVector (0,0,0);
    //  }
      
      //swing the sword:
      if (p1.currentAttackTime <= p1.swingTime)
      {
        p1.SetSwordAngle();
          if (p1.dirLeft == true)
          {
             p1.swordQuad =  p1.swordQuad.RotateQuad(p1.pos, PI *  ((float)p1.currentAttackTime/p1.swingTime)   );
             
             p1.swordCollPos1 = p1.RotateVector(p1.pos, PI *  ((float)p1.currentAttackTime/p1.swingTime), p1.swordCollPos1);
             p1.swordCollPos2 = p1.RotateVector(p1.pos, PI *  ((float)p1.currentAttackTime/p1.swingTime), p1.swordCollPos2); 
          }
          else
          {
            p1.swordQuad =  p1.swordQuad.RotateQuad(p1.pos, -PI *  ((float)p1.currentAttackTime/p1.swingTime)   );
            p1.swordCollPos1 = p1.RotateVector(p1.pos, -PI *  ((float)p1.currentAttackTime/p1.swingTime), p1.swordCollPos1);
            p1.swordCollPos2 = p1.RotateVector(p1.pos, -PI *  ((float)p1.currentAttackTime/p1.swingTime), p1.swordCollPos2); 
             
          }
      }
      else if (p1.currentAttackTime > p1.swingTime) //if the sword has been swung, hold it out in front of the player
      {
             p1.SetSwordAngle();
          if (p1.dirLeft == true)
          {
             p1.swordQuad =  p1.swordQuad.RotateQuad(p1.pos, PI   );
             p1.swordCollPos1 = p1.RotateVector(p1.pos, PI, p1.swordCollPos1);
             p1.swordCollPos2 = p1.RotateVector(p1.pos, PI, p1.swordCollPos2); 
          }
          else
          {
            p1.swordQuad =  p1.swordQuad.RotateQuad(p1.pos, -PI    );
            p1.swordCollPos1 = p1.RotateVector(p1.pos, -PI, p1.swordCollPos1);
            p1.swordCollPos2 = p1.RotateVector(p1.pos, -PI, p1.swordCollPos2); 
          }
      }
      
      
        p1.attacking = true;
        
        CollisionSwordOnEnemies();
    }
    else
    {
      p1.SetSwordAngle();
      p1.attacking = false;
      p1.currentAttackTime = 0;
      p1.currentAttackTimeInAir = 0;
      
      p1.mouseInput = new PVector((((float)mouseX + 3) - (float)width/2) * elapsedTime, (((float)mouseY + 25) - (float)height/2) * elapsedTime , 0); //the +3 and + 25 are something fucked, but it makes it work
           
       
       if (p1.mouseInput.mag() < mouseInputThreshold)
       {
         p1.mouseInput = new PVector (0,0,0);
       }
       else
       {
         float oldMagnitude = p1.mouseInput.mag();
         p1.mouseInput.normalize();
         p1.mouseInput.mult( oldMagnitude - mouseInputThreshold);
       }
     p1.prevMouseInput.set(p1.mouseInput);
   //  System.out.println("elapsedTime " + elapsedTime + " Mouse X Y = " + mouseX + " " + mouseY);
    // PrintVector(p1.mouseInput); 
    }

    return -1;
  }
  
  void HandleMoveOnGround(long elapsedTime)
  {
    float mSpeed = p1.mouseInput.mag();
      PVector mInput = new PVector();
      mInput.set( p1.mouseInput ); //set to mouseInput because we only take input every other frame, and operating
      //directly on p1.mouseInput will fuck it all up.
      mInput.normalize();

      mInput.mult((float)elapsedTime/ ((width)/mSpeed)); //TODO: this is terrible.

      if (mInput.mag() > maxMouseSpeed)
      {
        mInput.normalize();
        mInput.mult(maxMouseSpeed);
      }
      
      if (right == true)
      {
       // float timeFactor = 1 - (( (float)p1.currentAttackTime / (float)p1.attackTime) );
        float timeFactor = 1 - (( ((float)p1.currentAttackTime - p1.currentAttackTimeInAir ) 
                               / (float)p1.attackTime) );
        
        if (timeFactor <0)
          timeFactor = 0;
          
        mInput.mult(timeFactor);
        // mInput.mult(0.01);
      }
     
      
      PVector move = Orbit(p1.pos, mInput, p1.onPlanet.pos);// PVector.sub( (PVector.add(p1.pos,mInput)), p1.onPlanet.pos);
      

      p1.velocity = (move);
  }

  void Update(long elapsedTime)
  { 
    
    //only update input 30 times per second:
    inputCounter++;
    if (inputCounter > 0)
    {  
      int stateID = TakeInput(elapsedTime); //if stateID != -1, then change to the correct state.
      inputCounter = 0;  
    }
   // if (mouseLocked)
    //  ResetMouse();


    PVector planetaryForce = new PVector(0,0,0);

    //IF ON A PLANET
    if (p1.grounded)  
    {      
      
       HandleMoveOnGround(elapsedTime);


    }
    //ELSE IF IN AIR
    else 
    {
      //Loop through planets and apply force to player according to distance from planet and size of planet.
      for (int i = 0; i < planetList.size(); i++)
      {
        if ( (CircleCollision(p1.pos, /*p1.radius*/ 0.01f, ((Planet)planetList.get(i)).pos, ((Planet)planetList.get(i)).radiusOfEffect)).mag() > 0 )
        {

          PVector force = new PVector(((Planet)planetList.get(i)).pos.x - p1.pos.x, 
          ((Planet)planetList.get(i)).pos.y - p1.pos.y, 0);

          float magnitude = force.mag();
          
          
          force.normalize();

          float forceFactor = (magnitude - ((Planet)planetList.get(i)).radius ) /  
          (((Planet)planetList.get(i)).radiusOfEffect - ((Planet)planetList.get(i)).radius);

          forceFactor = 1 - forceFactor;
          
          forceFactor *= elapsedTime;
              
          force.mult( forceFactor );
        
          planetaryForce.add(force);

        }
      }  



      if (planetaryForce.mag() >0) 
      {
        p1.down.set(  planetaryForce );
      }
      else //if outside of all planets' gravity, make the player fall slowly to the closest planet.
      {
        Planet closestPlanet = ((Planet)planetList.get(0));

        float distToClosestPlanet = (PVector.sub(((Planet)planetList.get(0)).pos, p1.pos)).mag() - ((Planet)planetList.get(0)).radius;
        p1.down.set(PVector.sub(closestPlanet.pos, p1.pos));

        if (planetList.size() > 1)
        {
          for (int i = 1; i < planetList.size(); i++)
          {
            float distToPlanet = (PVector.sub(((Planet)planetList.get(i)).pos, p1.pos)).mag() - ((Planet)planetList.get(i)).radius;
            if (distToPlanet < distToClosestPlanet)
            {
              distToClosestPlanet = distToPlanet;

              closestPlanet = (Planet)planetList.get(i);
              p1.down.set(PVector.sub(closestPlanet.pos, p1.pos));   

            }
          }
        }

        planetaryForce = new PVector(closestPlanet.pos.x - p1.pos.x, 
        closestPlanet.pos.y - p1.pos.y, 0);
        planetaryForce.normalize();
        planetaryForce.mult(farAwayPlanetaryPull);
        
      }

      p1.down.normalize();
      p1.down.mult(50);
      p1.down.add(p1.pos);
      //p1.downQuad.MoveTo(p1.down);


      //TAKE MOUSE INPUT AND MOVE THE PLAYER
      float mSpeed = p1.mouseInput.mag();
      PVector mInput = new PVector();
      mInput.set( p1.mouseInput ); //set to mouseInput because we only take input every other frame, and operating
      //directly on p1.mouseInput will fuck it all up.
      mInput.normalize();

      mInput.mult((float)elapsedTime /32); //TODO: this is terrible.

      if (mInput.mag() > (maxMouseSpeed *p1.inAirMouseInputMod))
      {
        mInput.normalize();
        mInput.mult((maxMouseSpeed *p1.inAirMouseInputMod));
      }

      PVector move = Orbit(p1.pos, mInput, p1.down);// PVector.sub( (PVector.add(p1.pos,mInput)), p1.onPlanet.pos);
     
      p1.velocity.add(move);

      planetaryForce.div(12);
      
      p1.velocity.add(planetaryForce);
      


    }

    //air resistance:
    p1.velocity.mult(1 - ((float)elapsedTime / (float)1000));
    
    
    //p1.velocity.mult(0.99);
    //translate the player based on his calculated velocity
    p1.Translate(p1.velocity);  


    if (p1.grounded)
    {
       if (p1.FindAngle2D(p1.velocity, PVector.sub(p1.onPlanet.pos, p1.pos)) > 0)
      {
        p1.SetPlayerDir(false);
      }
      else if (p1.FindAngle2D(p1.velocity, PVector.sub(p1.onPlanet.pos, p1.pos)) < 0)
      {
        p1.SetPlayerDir(true);
      }
    }
        p1.SetPlayerAngle();
    //Translate camera;
    cameraa.pos.add( PVector.mult( PVector.sub(p1.pos, cameraa.pos), 0.05 ) ); //0.05

    
    
    enMan.Update(elapsedTime, p1.pos, ((Planet)planetList.get( (int)random(planetList.size()-1) )).pos );
    
     CollisionPlayerOnPlanet();
     CollisionEnemiesOnPlanet();
     CollisionPlayerOnEnemy();
     
  }

  void CollisionSwordOnEnemies()
  {
    for (int i = enMan.enemiesList.size()-1; i >= 0; i--)
    {
      //if the enemy is generally close..
      if ( CircleCollisionNoOverlap(p1.swordQuad.center, p1.swordImg.width*2, 
          ((Enemy)enMan.enemiesList.get(i)).pos, ((Enemy)enMan.enemiesList.get(i)).radius) ) 
          {
            //if the enemy is colliding with the sword:
          if ( CircleCollisionNoOverlap(p1.swordCollPos1, p1.swordCollRadius1, 
          ((Enemy)enMan.enemiesList.get(i)).pos, ((Enemy)enMan.enemiesList.get(i)).radius) ) 
          {
            enMan.enemiesList.remove(i);
            continue;
          }
          
          if ( CircleCollisionNoOverlap(p1.swordCollPos2, p1.swordCollRadius2, 
          ((Enemy)enMan.enemiesList.get(i)).pos, ((Enemy)enMan.enemiesList.get(i)).radius) ) 
          {     
            enMan.enemiesList.remove(i);
            continue; 
          } 
            
            
          }
    }
    
  }
  void CollisionEnemiesOnPlanet()
  {
    Planet closestPlanet = new Planet();

    
    if (enMan.enemiesList.size() > 0)
    {
        for (int i = 0; i < enMan.enemiesList.size(); i++)
        {
          //if the enemy is in flight mode...
          if (((Enemy)enMan.enemiesList.get(i)).mode ==0)
          {
          closestPlanet.set( (Planet)planetList.get(0) ) ; 
          for  (int j = 0; j < planetList.size(); j++)
          {
           // if a planet is closer, set that to be the closest Planet.
              if (  ((PVector.sub(closestPlanet.pos, ((Enemy)enMan.enemiesList.get(i)).pos)).mag() - closestPlanet.radius)  > 
                   ((PVector.sub(((Planet)planetList.get(j)).pos, ((Enemy)enMan.enemiesList.get(i)).pos)).mag() - ((Planet)planetList.get(j)).radius) )
                {
                  closestPlanet.set( ((Planet)planetList.get(j)) );
                }
          }
          //now do a bounding circle check on the closest planet to see if it has landed on it yet.
          PVector overlap = CircleCollision( ((Enemy)enMan.enemiesList.get(i)).pos,((Enemy)enMan.enemiesList.get(i)).radius,
                                              closestPlanet.pos, closestPlanet.radius);
          if (overlap.mag() != 0)
          {
            ((Enemy)enMan.enemiesList.get(i)).Translate(PVector.mult(overlap,0.99));
            ((Enemy)enMan.enemiesList.get(i)).mode = 1;
          }
          }
          
        }  
    }

    
  }
  
  void CollisionPlayerOnEnemy() //death case
  {
     if (enMan.enemiesList.size() > 0)
    {
        for (int i = 0; i < enMan.enemiesList.size(); i++)
        {
          if (CircleCollisionNoOverlap(p1.pos, p1.radius, ((Enemy)enMan.enemiesList.get(i)).pos, ((Enemy)enMan.enemiesList.get(i)).radius))
          {
            p1.life -= 1;
             // p1.Translate(PVector.add(PVector.mult(p1.pos, -1), new PVector( ((Planet)planetList.get(0)).pos.x+((Planet)planetList.get(0)).radius  , ((Planet)planetList.get(0)).pos.y+((Planet)planetList.get(0)).radius, 0)));
             // p1.velocity = new PVector(); //Vector.sub( p1.pos;
             // p1.grounded = false;
             // cameraa.pos.add( PVector.mult(PVector.sub(p1.pos, cameraa.pos), 0.5)   );
          }
        }
    }
  }
  
  void CollisionPlayerOnPlanet()
  {

    if (p1.grounded == false)
    {

      for (int i = 0; i < planetList.size(); i++)
      {


        PVector overlap = CircleCollision(p1.pos, p1.radius, ((Planet)planetList.get(i)).pos, ((Planet)planetList.get(i)).radius);

        if (overlap.mag() > 0)
        {
          p1.Translate(PVector.mult(overlap,0.99));

         // p1.jumping = false;
          p1.jumpCounter = 0;

          p1.grounded = true;     

          p1.onPlanet = (Planet)planetList.get(i);
          p1.down.set( p1.onPlanet.pos);

         // p1.downQuad.MoveTo(p1.down);

        }
      }
    }
  }

  boolean CircleCollisionNoOverlap(PVector aPos, float aRadius, PVector bPos, float bRadius)
  {
    if ((PVector.sub(aPos, bPos)).mag() < (aRadius + bRadius))
      return true;
    else
      return false;
  }
  
  PVector CircleCollision(PVector aPos, float aRadius, PVector bPos, float bRadius)
  {
    if ((PVector.sub(aPos, bPos)).mag() < (aRadius + bRadius))
    {
      PVector distance = (PVector.sub(aPos, bPos));

      float overlap = (aRadius + bRadius) - distance.mag();

      distance.normalize();
      if (distance.mag() ==0)
        distance.x = 0.1;

      return PVector.mult(distance, overlap);

    }
    else
      return new PVector(0,0,0);
  }



  //Function that takes in a velocity vector, and returns a new dir vector to orbit around the vector planetPos.
  PVector Orbit(PVector pos, PVector dir, PVector planetPos)
  {
    PVector newVector = PVector.add(pos, dir);

    newVector.sub(planetPos);

    newVector.normalize();

    newVector.mult( (PVector.sub(pos, planetPos)).mag() );

    newVector.add(planetPos);

    newVector.sub(pos);

    return newVector;

  }


//  void ResetMouse()
//  {
//    centerPosX = (int)(frame.getLocation().getX() + width/2);
//    centerPosY = (int)(frame.getLocation().getY() + height/2);
//
//    try { 
//
//      Robot robot = new Robot(); 
//      // Creates the delay of 5 sec so that you can open notepad before 
//      // Robot start writting 
//
//      robot.mouseMove(centerPosX,centerPosY);
//
//    } 
//    catch (AWTException e) { 
//      e.printStackTrace(); 
//    }
//  }

  void Draw(long elapsedTime)
  {    
    //noCursor(); //hides the cursor

      background(0); //background colour

    ortho( - cameraa.cwidth , 
    cameraa.cwidth , 
    - cameraa.cheight, 
    cameraa.cheight , -100, 100);

    camera(cameraa.pos.x, cameraa.pos.y, 10, // eyeX, eyeY, eyeZ
    cameraa.pos.x, cameraa.pos.y, 0.0, // lookX, lookY, lookZ
    0.0, 1.0, 0.0); // upX, upY, upZ


    for (int i = 0; i < planetList.size(); i++)
    {
      ((Planet)planetList.get(i)).Draw();
    }
    p1.Draw();

    enMan.Draw();
    
    gui.Draw(elapsedTime); 
  }


  void PrintVector(PVector vec)
  {
    System.out.println("vec x y z: " + vec.x + " " + vec.y + " " + vec.z  );
  }
  



boolean left=false;
boolean right=false;
boolean center=false;

void mousePressed()
{
  if(mouseButton==LEFT)
    left=true;
  if(mouseButton==RIGHT)
    right=true;
  if(mouseButton==CENTER)
    center=true;
}

void mouseReleased()
{
  if(mouseButton==LEFT)
    left=false;
  if(mouseButton==RIGHT)
    right=false;
  if(mouseButton==CENTER)
    center=false;
} 


}













