class Player extends Entity
{
  int life = 100;
  boolean dirLeft = true;

  PVector velocity = new PVector(0,0,0);


  PVector mouseInput = new PVector(0,0,0); //used to store the current mouse input
  PVector prevMouseInput = new PVector(0,0,0);

  PVector down = new PVector(0,0,0);
  Planet onPlanet;

  boolean grounded = false;

  PImage img;

  float radius; //for starters, after basic system in, will implement rotation and quad coll.

  Quad2D originalQuadd;
  Quad2D quadd;

//  Quad2D downQuad;
//  PImage downImg;
  Quad2D swordQuad;
  PImage swordImg;
  
  //stuff for attacking:
  int currentAttackTime = 0;
  int currentAttackTimeInAir = 0; //so that when the player lands, they still do a slide even if they have been in the air for a long time.
  int attackTime = 1000;
  boolean attacking = false;
  int swingTime = 140; //milliseconds
  PVector swordCollPos1;
  float swordCollRadius1 = 15;
  PVector swordCollPos2;
  float swordCollRadius2 = 15;
  
  //stuff for jumping:
  boolean jumping = false;
  int jumpCounter = 0;
  int jumpMax = 255; //15
  float jumpPower = 11.5f; //initial jump power
  float jumpBoost = 0.00043f; //sustained jump multiplier
  
  float  inAirMouseInputMod = 0.03;
  
  Player()
  {
    //    img = loadImage("warrior1.png");
    //   // quad = new Quad2D();
    //    pos = new PVector(width/2 , height/2 +1);
    //    quadd = new Quad2D(new PVector(width/2, height/2 +1), 32, 32);
    //    originalQuadd = new Quad2D(new PVector(width/2, height/2 +1), 32, 32);
    //    
    //    downQuad = new Quad2D(new PVector(width/2, height/2 +1), 8, 8);
    //    downImg = loadImage("biggreencircle.png");
    //    
    //    swordQuad = new Quad2D(new PVector(pos.x, pos.y), 8, 8);
    //    swordImg = loadImage("sword1.png");
    //    
    //    radius = 16;
  }

  Player(PVector iPos, float iWidth, float iHeight)
  {
    img = loadImage("warrior1.png");
    radius = iHeight/2;      
    pos = iPos;
    quadd = new Quad2D(pos, iWidth*1.2, iHeight*1.2);
    originalQuadd = new Quad2D(pos, iWidth*1.2, iHeight*1.2);

//    downQuad = new Quad2D(new PVector(width/2, height/2 +5), 16, 16);
//    downImg = loadImage("biggreencircle.png");


    swordImg = loadImage("sword1.png");
    swordQuad = new Quad2D (new PVector(pos.x - swordImg.width + swordImg.width*0.35, pos.y), 
                             swordImg.width, swordImg.height);
                             
     swordCollPos1 = new PVector(pos.x - swordImg.width + swordImg.width*0.025, pos.y);
     swordCollPos2 = new PVector(pos.x - swordImg.width + swordImg.width*0.37, pos.y);
     

    
  }

  //  void Move(int hor, int ver)
  //  {
  //    
  //    pos = new PVector(hor, ver, pos.z);
  //    quadd.Translate(new PVector(hor, ver, 0));
  //    swordQuad.Translate(new PVector(hor, ver, 0));
  //  }

  void Update()
  {
  }

  void Translate(PVector iVelocity)
  {
    //iVelocity.mult(0.15);

    pos.add(iVelocity);
    swordCollPos1.add(iVelocity);
    swordCollPos2.add(iVelocity);
    //  quadd.MoveTo(pos);

    quadd.Translate(iVelocity);

    swordQuad.Translate(iVelocity);
  }

  float FindAngle2D(PVector v1, PVector v2)
  {
    //float angle = -(180/PI)*atan2(v1.x*v2.y - v1.y*v2.x, v1.x*v2.x+v1.y*v2.y);
    float angle = -atan2(v1.x*v2.y - v1.y*v2.x, v1.x*v2.x+v1.y*v2.y);

    return angle;
  }

  PVector ReturnNormal(PVector v1, boolean clockwise)
  {
    PVector normalV1 = new PVector();
    normalV1.set(v1);

    if (clockwise)
    {
      float y = normalV1.y;
      normalV1.y = -normalV1.x;
      normalV1.x = y;
    }
    else
    {
      float y = normalV1.y;
      normalV1.y = normalV1.x;
      normalV1.x = -y;
    }

    return normalV1;
  }

  void MirrorPlayer()
  {
    quadd.MirrorQuad(down, pos);
    //originalQuadd.MirrorQuad(down, pos);
    swordQuad.MirrorQuad(down, pos);
    swordCollPos1 = MirrorVector2D( swordCollPos1, down, pos);
    swordCollPos2 = MirrorVector2D( swordCollPos2, down, pos);
    
    
    PVector temp0 = new PVector();
    temp0.set( originalQuadd.points[0]);
    PVector temp2 = new PVector();
    temp2.set( originalQuadd.points[2]);

    originalQuadd.points[0] = originalQuadd.points[1];
    originalQuadd.points[1] = temp0;
    originalQuadd.points[2] = originalQuadd.points[3];
    originalQuadd.points[3] = temp2;
  }

  void SetPlayerDir(boolean left)
  {
    if (left != dirLeft)
    {
      //mirror the geometry along the axis between p1.pos and the planets center.
      MirrorPlayer();

      dirLeft = left;
    }
  }
  
  void SetPlayerAngle()
  {
    //set player
    float anglebetween = FindAngle2D( PVector.sub(down, pos), new PVector(0,1,0) );
    originalQuadd.MoveTo(pos);    
    quadd = originalQuadd.RotateQuad(pos,anglebetween);
    
    if (attacking == false)
    {
      SetSwordAngle();
    }
  }
  
  void SetSwordAngle()
  {
    //set sword:
    
    float swordAngle = FindAngle2D( PVector.sub(swordQuad.center, pos), PVector.sub( down, pos));
    
    float newSwordAngle = 0;
    
    if (dirLeft == true) //see how it should rotate
      newSwordAngle = FindAngle2D( ReturnNormal(PVector.sub( down, pos), false), PVector.sub( down, pos));
    else
      newSwordAngle = FindAngle2D( ReturnNormal(PVector.sub( down, pos), true), PVector.sub( down, pos));  
      
    newSwordAngle -= swordAngle;
    swordQuad = swordQuad.RotateQuad(pos, newSwordAngle); //rotate the sword
    swordCollPos1 = RotateVector(pos, newSwordAngle, swordCollPos1);
    swordCollPos2 = RotateVector(pos, newSwordAngle, swordCollPos2); 
    
  }
  
   PVector  RotateVector(PVector rotAxis, float rotAmount, PVector rotVec)
  {
    PVector rotateVec = new PVector();
    rotateVec.set(rotVec);
    rotateVec.sub(rotAxis);
    PVector returnVec = new PVector();
    
    returnVec.x = (rotateVec.x *(cos(rotAmount))) - (rotateVec.y *(sin(rotAmount)));
    returnVec.y = (rotateVec.x *(sin(rotAmount))) + (rotateVec.y *(cos(rotAmount)));
    returnVec.add(rotAxis);
    return returnVec;
  }
  
   PVector MirrorVector2D(PVector v1, PVector axisA, PVector axisB)
  {
    PVector axis = PVector.sub(axisA, axisB);
    
    PVector axisNormal = ReturnNormal(axis, true);
    
    PVector mirrorVec = new PVector();
    
    mirrorVec.set(v1);
    mirrorVec.sub(axisB);
    mirrorVec = PVector.sub(mirrorVec, PVector.div( PVector.mult( axisNormal, 2*mirrorVec.dot(axisNormal) ), pow(axisNormal.mag(),2))     );
    mirrorVec.add(axisB);
      
     return mirrorVec;
  }
  
  void Draw()
  {
    quadd.Draw(img);

    //downQuad.MoveTo(swordCollPos2);
   // downQuad.Draw(downImg);

    swordQuad.Draw(swordImg);
  }

  
}



